import { CorTabPaneComponent } from './cor-tab-pane.component';
import { CorTabPanelComponent } from '../cor-tab-panel/cor-tab-panel.component';
import { Mock } from 'ts-mocks';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import Spy = jasmine.Spy;


describe("CorTabPaneComponent", () => {
  var component: CorTabPaneComponent;
  var panelMock: Mock<CorTabPanelComponent>;
  var activeTab: BehaviorSubject<string>;

  beforeEach(() => {
    activeTab = new BehaviorSubject<string>(null);
    spyOn(activeTab, "subscribe").and.returnValue(null);
    panelMock = new Mock<CorTabPanelComponent>();
    panelMock.setup(mock => mock.activeTab).is(activeTab);

    component = new CorTabPaneComponent(panelMock.Object);
  });

  describe("ngOnInit", () => {

    beforeEach(() => {
      panelMock.setup(mock => mock.addTabPane);
    });

    it("adds self as tab pane to panel", () => {
      component.ngOnInit();

      expect((<Spy>panelMock.Object.addTabPane).calls.argsFor(0)[0]).toBe(component);
    });

    it("subscribes to active tab changes", () => {
      component.ngOnInit();

      expect((<Spy>panelMock.Object.activeTab.subscribe)).toHaveBeenCalled();
    });
  });
});
